Change total spent time link to global time entries when issue has subtasks that can be on non

descendent projects

2021-04-20 15:39 - Dmitry Makurin 

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 4.1.4   

Resolution: Fixed Affected version: 4.2.0

Description

Parent issue displays total spent hours. It includes self time entries and all of subtasks and also gives user a link to time_entries

controller. Link leads to time_entries inside a parent issue project so if any of subtask will be in different project than parent you won't

see it.

Issue.total_spent_hours does not filter time entries by a project.

I guess it's more natural to give link to time_entries instead projects/:id/time_entries.

Index: app/helpers/issues_helper.rb

<+>UTF-8

===================================================================

diff --git a/app/helpers/issues_helper.rb b/app/helpers/issues_helper.rb

--- a/app/helpers/issues_helper.rb    (revision ad087516f4f11bb530ea96777e3edc32940e323b)

+++ b/app/helpers/issues_helper.rb    (revision 3c8f6a9152e28c5057710f68b13559db56990dbf)

@@ -259,7 +259,7 @@

   def issue_spent_hours_details(issue)

     if issue.total_spent_hours > 0

-      path = project_time_entries_path(issue.project, :issue_id => "~#{issue.id}")

+      path = time_entries_path(:issue_id => "~#{issue.id}")

       if issue.total_spent_hours == issue.spent_hours

         link_to(l_hours_short(issue.spent_hours), path)

Associated revisions

Revision 21082 - 2021-07-26 22:28 - Marius BĂLTEANU

Link total spent time to global time entries page when cross_project_issue_relations are allowed in order to include time entries from other projects

(#35134).

Revision 21083 - 2021-07-26 22:49 - Marius BĂLTEANU

Revert r21082 (#35134).

Revision 21084 - 2021-07-26 22:51 - Marius BĂLTEANU

Revert r21082 (#35134).

Revision 21085 - 2021-07-26 22:55 - Marius BĂLTEANU

Total spent time from issue page should link to global time entries if the issue has subtasks and the subtasks can be on projects that are not

descendants of the current project (#35134).

Revision 21092 - 2021-07-27 22:38 - Marius BĂLTEANU

Merged r21085 to 4.2-stable (#35134).

Revision 21095 - 2021-07-27 22:46 - Marius BĂLTEANU

Merged r21085 to 4.1-stable (#35134).
Revision 21102 - 2021-07-28 17:51 - Marius BĂLTEANU

Fixes failing tests on Ruby 2.4 (#35134).

Revision 21103 - 2021-07-28 17:53 - Marius BĂLTEANU

Merged r21102 to 4.1-stable (#35134).

History

#1 - 2021-04-26 22:47 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

- Target version set to 4.1.4

#2 - 2021-05-30 23:16 - Marius BĂLTEANU

- Status changed from New to Needs feedback

- Assignee deleted (Marius BĂLTEANU)

Indeed, giving link to time_entries instead projects/:id/time_entries fixes this, but with a downside, the user context is changed from project level to

global level.

What about setting the link to time_entries only when the "Allow cross-projects subtasks" is set to "With all projects"? If I'm not wrong, this is the only

case when this issue reproduces.

#3 - 2021-05-30 23:16 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

#4 - 2021-06-02 09:26 - Dmitry Makurin 

Marius BALTEANU wrote:

What about setting the link to time_entries only when the "Allow cross-projects subtasks" is set to "With all projects"? If I'm not wrong, this is the

only case when this issue reproduces.

 Yes, it is. Agreed that is a better approach, I'll try to redo the patch.

#5 - 2021-07-03 15:57 - Marius BĂLTEANU

- File 0001-Link-to-global-time-entries-if-issue-has-subtasks-an.patch added

Here is the patch.

#6 - 2021-07-03 16:05 - Marius BĂLTEANU

The implementation links to global path instead of project path only when:

the total spent time is greater than spent time (means that the issue has subtasks with time entries logged) and

setting "Allow cross-project subtasks" is "With all projects", "With project tree" or "With project hierarchy".

#7 - 2021-07-26 22:30 - Marius BĂLTEANU

- Status changed from Needs feedback to Resolved

Patch committed.

#8 - 2021-07-26 23:07 - Marius BĂLTEANU

- Resolution set to Fixed

#9 - 2021-07-27 22:50 - Marius BĂLTEANU

- Status changed from Resolved to Closed

#10 - 2021-07-28 07:53 - Go MAEDA

- Status changed from Closed to Reopened

IssuesHelperTest in 4.2-stable and 4.1-stable branches fails with Ruby 2.4.
laphroaig:4.2-stable maeda$ ruby test/helpers/issues_helper_test.rb

Run options: --seed 4533

# Running:

....F

Failure:

IssuesHelperTest#test_issue_spent_hours_details_should_link_to_project_time_entries_depending_on_cross_project

_setting [test/helpers/issues_helper_test.rb:385]:

Expected /href="\/projects\/ecookbook\/time_entries\?issue_id=~1"/ to match "154.25 h (Total: <a href=\"/proje

cts/ecookbook/time_entries?issue_id=%7E1\">161.25 h</a>)".

bin/rails test test/helpers/issues_helper_test.rb:379

...........................F

Failure:

IssuesHelperTest#test_issue_spent_hours_details_should_link_to_global_time_entries_depending_on_cross_project_

setting [test/helpers/issues_helper_test.rb:396]:

Expected /href="\/time_entries\?issue_id=~1"/ to match "154.25 h (Total: <a href=\"/time_entries?issue_id=%7E1

\">161.25 h</a>)".

bin/rails test test/helpers/issues_helper_test.rb:390

#11 - 2021-07-28 17:55 - Marius BĂLTEANU

Thanks for reporting the failures, I've committed the fixes.

Considering that the issue reproduces only on Ruby 2.4 which is no longer supported on trunk, is it ok to fix the tests only on 4.2-stable and 4.1-stable

branches?

#12 - 2021-07-30 09:29 - Marius BĂLTEANU

- Status changed from Reopened to Closed

#13 - 2021-07-30 09:30 - Marius BĂLTEANU

- Subject changed from Change total spent time link to global time entries to Change total spent time link to global time entries when issue has

subtasks that can be on non descendent projects

#14 - 2021-08-01 08:46 - Marius BĂLTEANU

- Category set to Issues

Files

0001-Link-to-global-time-entries-if-issue-has-subtasks-an.patch 2.71 KB 2021-07-03 Marius BĂLTEANU
